/*
 *
 * framebuff.h
 *
 */


#ifndef FRAMEBUFF_H
#define FRAMEBUFF_H


#include <stdio.h>
#include <setjmp.h>
#include <fcntl.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>

#ifdef X_SHM
#include <sys/ipc.h>
#include <sys/shm.h>
#include <X11/extensions/XShm.h>
#endif

/* X11/xmd.h correctly defines INT32, etc */
#ifndef XMD_H
typedef int INT32;
typedef short INT16;
typedef char INT8;
#endif
typedef unsigned int UINT32;
typedef unsigned short UINT16;
typedef unsigned char UINT8;

#include <stdlib.h>
#include <stdio.h>
#include "stdmok.h"

/*
#define D_WIDTH  400
#define D_HEIGHT 300
*/


#ifdef D_HIRES
#define D_WIDTH  640
#define D_HEIGHT 480
#else
#define D_WIDTH  320
#define D_HEIGHT 200
#endif

#define pix(x,y)        (d_graph_mem[D_WIDTH*(y)+(x)])


extern unsigned char d_cmap[];

void graph_swap PRM(());

#define graph_clear(c)  memset(d_graph_mem, d_cmap[c], D_WIDTH * D_HEIGHT) 
#define z_clear()       memset(d_z_mem, 0, D_WIDTH * D_HEIGHT * sizeof(long))

void SetRGB  PRM((int n,int r,int g,int b));

void OpenS   PRM(());
void CloseS  PRM(());
void Bleed   PRM((int fildes, int ndelay));
int  readkbd PRM((char *c));


typedef struct 
  {
#ifdef X_SHM
  XShmSegmentInfo shminfo;               /* Segment info.  */
#endif
  XImage  *ximage;                       /* Ximage struct. */
  Display *display;
  Window   window;
  GC       gc;
  Colormap cmap;
  char    *name;
  int      shmemFlag;
  char    *graph_mem;
  } XWND;

#ifndef FRAMEBUFF_C
extern long *d_z_mem;
extern char *d_graph_mem;
extern char *r_graph_mem;   /* no real graph mem ptr with X */
extern char *v_graph_mem;
#endif

#endif
