
/*
 *
 * gl_2d.c
 *
 */

#define GL_2D_C
#include "gl_2d.h"
#include <limits.h>

/* Ordered dithering matrices */

int D8[64] =
   {  0, 32,  8, 40,  2, 34, 10, 42 ,
     48, 16, 56, 24, 50, 18, 58, 26 ,
     12, 44,  4, 36, 14, 46,  6, 38 ,
     60, 28, 52, 20, 62, 30, 54, 22 ,
      3, 35, 11, 43,  1, 33,  9, 41 ,
     51, 19, 59, 27, 49, 17, 57, 25 ,
     15, 47,  7, 39, 13, 45,  5, 37 ,
     63, 31, 55, 23, 61, 29, 53, 21 };

int D4[16] =
   {  0,  8,  2,  10,
     12,  4, 14,   6,
      3, 11,  1,   9,
     15,  7, 13,   5  };

int D2[4] =
   { 0,  2,
     1,  3  };   


#define D_MASK   3
#define D_SHIFT  2
#define D_MATRIX D2
#define D_MASK_XY  1
#define D_SHIFT_XY 1
 
    
/*
#define D_MASK   15
#define D_SHIFT  4
#define D_MATRIX D4
#define D_MASK_XY  3
#define D_SHIFT_XY 2
 */
/*
#define D_MASK     63
#define D_SHIFT    6
#define D_MATRIX   D8
#define D_MASK_XY  7
#define D_SHIFT_XY 3
 */    
Mug mug[2*D_HEIGHT];


void DrawRect(r,c)

     Rect *r;
     int c;

{
  int x,y;
  c = d_cmap[c];

  for(x=r->x1; x<=r->x2; x++)
    {
      pix(x,r->y1) = c;
      pix(x,r->y2) = c;
    }

  for(y=r->y1; y<=r->y2; y++)
    {
      pix(r->x1,y) = c;
      pix(r->x2,y) = c;
    }
}

void SetPixel(x,y,c)

     int x,y,c;

   {
   x += Origin.x;
   y += Origin.y;

   if(!_clip_mode || InRect(&Clip,x,y))
     pix(x,y) = d_cmap[c];
   }



void Line(x1, y1, x2, y2, c)

     int x1,y1,x2,y2;
     int c;

   {


   int x,y,dx,dy,sx,sy;
   int e,swp,tmp,i;


   c = d_cmap[c];

   dx = x2 - x1;
   dy = y2 - y1;
   x = x1 + Origin.x;
   y = y1 + Origin.y;
   sx = SGN(dx);
   sy = SGN(dy);
   dx *= sx;
   dy *= sy;

   if(dy > dx)
	{
	tmp = dy;
	dy = dx;
	dx = tmp;
	swp = 1;
	}
   else
	swp = 0;


   e = (dy << 1) - dx;
   for(i=0; i<dx; i++)
	{
	if(!_clip_mode || InRect(&Clip,x,y))
	  pix(x,y) = c;
	while(e >= 0)
	    {
	    if(swp)
	       x += sx;
	    else
	       y += sy;
	    e -= (dx << 1);
	    }
	if(swp)
	   y += sy;
	else
	   x += sx;
	e += (dy << 1);
	}
   }


/*
void Line(x1, y1, x2, y2, c)

     int x1,y1,x2,y2;
     int c;

   {


   int x,y,dx,dy,sx,sy;
   int e,swp,tmp,i;
   direct_polygon P;
   
   P.v2[0].x = x1;
   P.v2[0].y = y1;
   P.v2[1].x = x2;
   P.v2[1].y = y2;
   P.nv2 = 2;
   ClipPoly(&P);

   dx = _poly1.pv2[1]->x - _poly1.pv2[0]->x;
   dy = _poly1.pv2[1]->y - _poly1.pv2[0]->y;

   x  = _poly1.pv2[0]->x;
   y  = _poly1.pv2[0]->y;
   sx = SGN(dx);
   sy = SGN(dy);
   dx *= sx;
   dy *= sy;

   if(dy > dx)
	{
	tmp = dy;
	dy = dx;
	dx = tmp;
	swp = 1;
	}
   else
	swp = 0;


   e = (dy << 1) - dx;
   for(i=0; i<dx; i++)
	{
	pix(x,y) = c;
	while(e >= 0)
	    {
	    if(swp)
	       x += sx;
	    else
	       y += sy;
	    e -= (dx << 1);
	    }
	if(swp)
	   y += sy;
	else
	   x += sx;
	e += (dy << 1);
	}
   }
*/

void _line(x1, y1, x2, y2, c)

     int x1,y1,x2,y2;
     int c;

   {

   int x,y,dx,dy,sx,sy;
   int e,swp,tmp,i;

   c = d_cmap[c];

   dx = x2 - x1;
   dy = y2 - y1;
   x = x1;
   y = y1;
   sx = SGN(dx);
   sy = SGN(dy);
   dx *= sx;
   dy *= sy;

   if(dy > dx)
	{
	tmp = dy;
	dy = dx;
	dx = tmp;
	swp = 1;
	}
   else
	swp = 0;


   e = (dy << 1) - dx;
   for(i=0; i<dx; i++)
	{
	pix(x,y) = c;
	while(e >= 0)
	    {
	    if(swp)
	       x += sx;
	    else
	       y += sy;
	    e -= (dx << 1);
	    }
	if(swp)
	   y += sy;
	else
	   x += sx;
	e += (dy << 1);
	}
   }


void __DrawPoly()

{
  int i,j,c;

  c = _poly1.npv2 ? _poly1.pv2[0]->c : 0;

  for(i=0; i < _poly1.npv2; i++)
    {
      j = i+1 == _poly1.npv2 ? 0 : i+1;
      _line(_poly1.pv2[i]->x,
	    _poly1.pv2[i]->y,
	    _poly1.pv2[j]->x,
	    _poly1.pv2[j]->y, c);
    }
}



void __DrawWhitePoly()

{
  int i,j,c;

  for(i=0; i < _poly1.npv2; i++)
    {
      j = i+1 == _poly1.npv2 ? 0 : i+1;
      _line(_poly1.pv2[i]->x,
	    _poly1.pv2[i]->y,
	    _poly1.pv2[j]->x,
	    _poly1.pv2[j]->y, 63);
    }
}


void __FillPoly()

   {
   int x1,y1,x2,y2;
   int dx,dy,sx,sy,e,i,j,k,x,y;
   int miny = BIG, maxy = -BIG;
   int c;

   char *graph_ptr;

   c = _poly1.npv2 ? _poly1.pv2[0]->c : 0;
   c = d_cmap[c];

   for(i=0; i < D_HEIGHT; i++)
     mug[i].init = 0;

   for(j=0; j < _poly1.npv2; j++)
      {
      k = j+1 == _poly1.npv2 ? 0 : j+1;

      x1 = _poly1.pv2[j]->x;
      y1 = _poly1.pv2[j]->y;
      x2 = _poly1.pv2[k]->x;
      y2 = _poly1.pv2[k]->y;


      if(!(dy = y2 - y1))
         continue;

      dx = x2 - x1;

      miny = MIN(y1,miny);
      maxy = MAX(y1,maxy);
      miny = MIN(y2,miny);
      maxy = MAX(y2,maxy);

      sx = SGN(dx); dx *= sx;
      sy = SGN(dy); dy *= sy;

      e = (dx << 1) - dy;
      x = x1;
      y = y1;

      for(i=0; i<=dy; i++)
	{

	if(mug[y].init)
	   {
	   mug[y].P1.x = MIN(mug[y].P1.x,x);
	   mug[y].P2.x = MAX(mug[y].P2.x,x);
	   }
	else
	   {
	   mug[y].init = 1;
	   mug[y].P1.x = mug[y].P2.x = x;
	   }

	while(e >= 0)
	   {
	   x += sx;
	   e -= dy << 1;
	   }

	y += sy;
	e += dx << 1;
	}
      }

   graph_ptr = d_graph_mem + D_WIDTH * miny;

   for(y = miny; y <= maxy; y++, graph_ptr += D_WIDTH)
      memset(graph_ptr + mug[y].P1.x, c, mug[y].P2.x - mug[y].P1.x + 1);
   }


void __FillWhitePoly()
   {
   _poly1.pv2[0]->c = 32;
   __FillPoly();
   __DrawWhitePoly();
   }

void __ShadePoly()

   {
   int x,y,c,dx,dy,dc;           /* bresenham engine */
   int sx,sy,sc,e,ec;            /* ...              */
   int miny = BIG, maxy = -BIG;  /* y-bounds         */
   int i,j,u;                    /* indices          */
   int x1,y1,x2,y2,c1,c2;        /* current line     */
   char *graph_ptr, *graph_ptr0; /* pixel pointers   */

   for(i=0; i<D_HEIGHT; i++)
     mug[i].init = 0;

   for(i=0; i<_poly1.npv2; i++)
      {
      j = i+1;

      if(j==_poly1.npv2)
	j = 0;

      x1 = _poly1.pv2[i]->x;
      y1 = _poly1.pv2[i]->y;
      x2 = _poly1.pv2[j]->x;
      y2 = _poly1.pv2[j]->y;


      if(!(dy = y2 - y1))
         continue;

      dx = x2 - x1;


      c1 = _poly1.pv2[i]->c;
      c2 = _poly1.pv2[j]->c;

      c1 = (int)(&d_cmap[c1]);
      c2 = (int)(&d_cmap[c2]);

      miny = MIN(y1,miny);
      maxy = MAX(y1,maxy);
      miny = MIN(y2,miny);
      maxy = MAX(y2,maxy);


      if(y1 == y2)
	continue;

      x = x1; y = y1; c = c1;
      dc = c2-c1;
      sx = SGN(dx); sy = SGN(dy);  sc = SGN(dc);
      dx *= sx;     dy *= sy;      dc *= sc;



      e = (dx << 1) - dy; ec = (dc << 1) - dy;
      for(u=0; u <= dy; u++)
	 {
	 if(mug[y].init)
	    {
	    if(x < mug[y].P1.x)
	       {
	       mug[y].P1.x = x;
	       mug[y].P1.c = c;
	       }
	    else
	    if(x > mug[y].P2.x)
	       {
	       mug[y].P2.x = x;
	       mug[y].P2.c = c;
	       }
	    }
	 else
	    {
	    mug[y].init = 1;
	    mug[y].P1.x = x;
	    mug[y].P2.x = x;
	    mug[y].P1.c = c;
	    mug[y].P2.c = c;
	    }

	 while(e >= 0)
	    {
	    x += sx;
	    e -= dy << 1;
	    }

	 while(ec >= 0)
	    {
	    c  += sc;
	    ec -= dy << 1;
	    }

	 y  += sy;
	 e  += dx << 1;
	 ec += dc << 1;
	 }

      }


   graph_ptr0 = d_graph_mem + miny * D_WIDTH;
   for(y = miny; y <= maxy; y++, graph_ptr0 += D_WIDTH)
      {

      graph_ptr = graph_ptr0 + mug[y].P1.x;
      dx = mug[y].P2.x - mug[y].P1.x;
      dc = mug[y].P2.c - mug[y].P1.c;
      sc = SGN(dc);
      dc *= sc;
      c = mug[y].P1.c;


      if(!dx)
	 {
	 *graph_ptr = *(char *)c;  
         continue;
         }

      ec = (dc << 1) - dx;

      for(i=0; i<=dx; i++)
	{

        *graph_ptr = *(char *)c;
	while(ec > 0)
	    {
	    c += sc;
	    ec -= (dx << 1);
	    }
	graph_ptr++;
	ec += (dc << 1);
	}
     }


   }




void __ShadePoly_dither()

   {
   int x,y,c,dx,dy,dc;           /* bresenham engine */
   int sx,sy,sc,e,ec;            /* ...              */
   int miny = BIG, maxy = -BIG;  /* y-bounds         */
   int i,j,u;                    /* indices          */   
   int x1,y1,x2,y2,c1,c2;        /* current line     */
   char *graph_ptr, *graph_ptr0; /* pixel pointers   */
   int c_cmap, c_coff;	         /* dithering stuff  */

   /* fill mugs */

   for(i=0; i<D_HEIGHT; i++)
     mug[i].init = 0;

   for(i=0; i<_poly1.npv2; i++)
      {
      j = i+1;

      if(j==_poly1.npv2)
	j = 0;

      x1 = _poly1.pv2[i]->x;
      y1 = _poly1.pv2[i]->y;
      x2 = _poly1.pv2[j]->x;
      y2 = _poly1.pv2[j]->y;
      c1 = _poly1.pv2[i]->c << D_SHIFT;
      c2 = _poly1.pv2[j]->c << D_SHIFT;

      miny = MIN(y1,miny);
      maxy = MAX(y1,maxy);
      miny = MIN(y2,miny);
      maxy = MAX(y2,maxy);


      if(y1 == y2)
	continue;

      x = x1; y = y1; c = c1;
      dx = x2-x1;   dy = y2-y1;    dc = c2-c1;
      sx = SGN(dx); sy = SGN(dy);  sc = SGN(dc);
      dx *= sx;     dy *= sy;      dc *= sc;

      e = (dx << 1) - dy; ec = (dc << 1) - dy;
      for(u=0; u <= dy; u++)
	 {
	 if(mug[y].init)
	    {
	    if(x < mug[y].P1.x)
	       {
	       mug[y].P1.x = x;
	       mug[y].P1.c = c;
	       }
	    else
	    if(x > mug[y].P2.x)
	       {
	       mug[y].P2.x = x;
	       mug[y].P2.c = c;
	       }
	    }
	 else
	    {
	    mug[y].init = 1;
	    mug[y].P1.x = x;
	    mug[y].P2.x = x;
	    mug[y].P1.c = c;
	    mug[y].P2.c = c;
	    }

	 while(e >= 0)
	    {
	    x += sx;
	    e -= dy << 1;
	    }

	 while(ec >= 0)
	    {
	    c  += sc;
	    ec -= dy << 1;
	    }

	 y  += sy;
	 e  += dx << 1;
	 ec += dc << 1;
	 }

      }


   /* fill poly */

   graph_ptr0 = d_graph_mem + miny * D_WIDTH;
   for(y = miny; y <= maxy; y++, graph_ptr0 += D_WIDTH)
      {


      graph_ptr = graph_ptr0 + mug[y].P1.x;
      dx = mug[y].P2.x - mug[y].P1.x + 1;
      dc = mug[y].P2.c - mug[y].P1.c;
      sc = SGN(dc);
      dc *= sc;
      c = mug[y].P1.c;

      ec = (dc << 1) - dx;
      for(i=0; i<dx; i++)
	{
	c_cmap = c >> D_SHIFT;
	c_coff = c &  D_MASK;

	if(D_MATRIX[((i+mug[y].P1.x) & D_MASK_XY) +
		((y & D_MASK_XY) << D_SHIFT_XY) ] < c_coff)
	c_cmap++;

/*	c_cmap = MIN(c_cmap,63); */

	*graph_ptr = c_cmap;

	while(ec >= 0)
	    {
	    c  += sc;
	    ec -= (dx << 1);
	    }
	graph_ptr++;
	ec += (dc << 1);
	}
     }

   }



void __ZBuffPoly()

   {
   int x,y,c,dx,dy,dc;             /* bresenham engine */
   int sx,sy,sc,e,ec;              /* ...              */
   int miny = BIG, maxy = -BIG;    /* y-bounds         */
   int i,j,u;                      /* indices          */
   int x1,y1,x2,y2,c1,c2;          /* current line     */
   long z1, z2, dz, sz, ez, z;     /* bresenham zbuff  */ 
   char *graph_ptr, *graph_ptr0;   /* pixel pointers   */
   long *z_ptr    , *z_ptr0;       /* zbuff pointers   */

   c = _poly1.npv2 ? _poly1.pv2[0]->c : 0;

   c = d_cmap[c];

   for(i=0; i<D_HEIGHT; i++)
     mug[i].init = 0;

   for(i=0; i<_poly1.npv2; i++)
      {
      j = i+1;

      if(j==_poly1.npv2)
	j = 0;

      x1 = _poly1.pv2[i]->x;
      y1 = _poly1.pv2[i]->y;
      x2 = _poly1.pv2[j]->x;
      y2 = _poly1.pv2[j]->y;


      if(!(dy = y2 - y1))
         continue;

      dx = x2 - x1;

      z1 = - _poly1.pv2[i]->z + GL_HUGE;
      z2 = - _poly1.pv2[j]->z + GL_HUGE;

      z1 = z1 >> Z_SHIFT;
      z2 = z2 >> Z_SHIFT;

      miny = MIN(y1,miny);
      maxy = MAX(y1,maxy);
      miny = MIN(y2,miny);
      maxy = MAX(y2,maxy);


      if(y1 == y2)
	continue;

      x = x1; y = y1; 

    
      z =  z1;
      dz = z2 - z1;
      sx = SGN(dx); sy = SGN(dy); sz  = SGN(dz); 
      dx *= sx;     dy *= sy;     dz *= sz;      



      e = (dx << 1) - dy; ez = (dz << 1) - dy; 
      for(u=0; u <= dy; u++)
	 {
	 if(mug[y].init)
	    {
	    if(x < mug[y].P1.x)
	       {
	       mug[y].P1.x = x;
	       mug[y].P1.z = z;
	       }
	    else
	    if(x > mug[y].P2.x)
	       {
	       mug[y].P2.x = x;
	       mug[y].P2.z = z;
	       }
	    }
	 else
	    {
	    mug[y].init = 1;
	    mug[y].P1.x = x;
	    mug[y].P2.x = x;
	    mug[y].P1.z = z;
	    mug[y].P2.z = z;
	    }

	 while(e >= 0)
	    {
	    x += sx;
	    e -= dy << 1;
	    }

	 while(ez >= 0)
	   {
	   z  += sz;
	   ez -= dy << 1;
	   }

	 y  += sy;
	 e  += dx << 1;
	 ez += dz << 1;
	 }

      }


   graph_ptr0 = d_graph_mem + miny * D_WIDTH;
   z_ptr0     = d_z_mem     + miny * D_WIDTH;
   for(y = miny; y <= maxy; y++, graph_ptr0 += D_WIDTH, z_ptr0 += D_WIDTH)
      {

      graph_ptr = graph_ptr0 + mug[y].P1.x;
      z_ptr     = z_ptr0     + mug[y].P1.x;
      dx = mug[y].P2.x - mug[y].P1.x;
      
      dz = mug[y].P2.z - mug[y].P1.z;
      sz = SGN(dz);
      dz *= sz;
      z  = mug[y].P1.z;

      if(!dx)
	 {
	 if(z > *z_ptr)  
	   {
	   *graph_ptr = c;
	   *z_ptr = z;
	   }
         continue;
         }


      ez = (dz << 1) - dx;

      for(i=0; i<=dx; i++)
	{
	if(z > *z_ptr)
	   {
           *graph_ptr = c;
	   *z_ptr     = z;
	   }

	while(ez > 0)
	  {
	  z += sz;
	  ez -= (dx << 1);
	  }

	graph_ptr++;
	z_ptr++;
	ez += (dz << 1);
	}
     }


   }


void __ZBuffShadePoly()

   {
   int x,y,c,dx,dy,dc;             /* bresenham engine */
   int sx,sy,sc,e,ec;              /* ...              */
   int miny = BIG, maxy = -BIG;    /* y-bounds         */
   int i,j,u;                      /* indices          */
   int x1,y1,x2,y2,c1,c2;          /* current line     */
   long z1, z2, dz, sz, ez, z;     /* bresenham zbuff  */ 
   char *graph_ptr, *graph_ptr0;   /* pixel pointers   */
   long *z_ptr    , *z_ptr0;       /* zbuff pointers   */


   for(i=0; i<D_HEIGHT; i++)
     mug[i].init = 0;

   for(i=0; i<_poly1.npv2; i++)
      {
      j = i+1;

      if(j==_poly1.npv2)
	j = 0;

      x1 = _poly1.pv2[i]->x;
      y1 = _poly1.pv2[i]->y;
      x2 = _poly1.pv2[j]->x;
      y2 = _poly1.pv2[j]->y;


      if(!(dy = y2 - y1))
         continue;

      dx = x2 - x1;

      c1 = _poly1.pv2[i]->c;
      c2 = _poly1.pv2[j]->c;

      c1 = (int)(&d_cmap[c1]);
      c2 = (int)(&d_cmap[c2]);

      z1 = - _poly1.pv2[i]->z + GL_HUGE;
      z2 = - _poly1.pv2[j]->z + GL_HUGE;

      z1 = z1 >> Z_SHIFT;
      z2 = z2 >> Z_SHIFT;

      miny = MIN(y1,miny);
      maxy = MAX(y1,maxy);
      miny = MIN(y2,miny);
      maxy = MAX(y2,maxy);


      if(y1 == y2)
	continue;

      x = x1; y = y1; c = c1; 
      dc = c2-c1;  
    
      z =  z1;
      dz = z2 - z1;
      sx = SGN(dx); sy = SGN(dy); sz  = SGN(dz);  sc = SGN(dc); 
      dx *= sx;     dy *= sy;     dz *= sz;       dc *= sc;     



      e = (dx << 1) - dy; ez = (dz << 1) - dy; ec = (dc << 1) - dy; 
      for(u=0; u <= dy; u++)
	 {
	 if(mug[y].init)
	    {
	    if(x < mug[y].P1.x)
	       {
	       mug[y].P1.x = x;
	       mug[y].P1.c = c;  
	       mug[y].P1.z = z;
	       }
	    else
	    if(x > mug[y].P2.x)
	       {
	       mug[y].P2.x = x;
	       mug[y].P2.c = c;  
	       mug[y].P2.z = z;
	       }
	    }
	 else
	    {
	    mug[y].init = 1;
	    mug[y].P1.x = x;
	    mug[y].P2.x = x;
	    mug[y].P1.z = z;
	    mug[y].P2.z = z;
	    mug[y].P1.c = c;
	    mug[y].P2.c = c; 
	    }

	 while(e >= 0)
	    {
	    x += sx;
	    e -= dy << 1;
	    }

	 while(ez >= 0)
	   {
	   z  += sz;
	   ez -= dy << 1;
	   }

	 while(ec >= 0)
	    {
	    c  += sc;
	    ec -= dy << 1;
	    } 

	 y  += sy;
	 e  += dx << 1;
	 ez += dz << 1;
	 ec += dc << 1; 
	 }

      }


   graph_ptr0 = d_graph_mem + miny * D_WIDTH;
   z_ptr0     = d_z_mem     + miny * D_WIDTH;
   for(y = miny; y <= maxy; y++, graph_ptr0 += D_WIDTH, z_ptr0 += D_WIDTH)
      {

      graph_ptr = graph_ptr0 + mug[y].P1.x;
      z_ptr     = z_ptr0     + mug[y].P1.x;
      dx = mug[y].P2.x - mug[y].P1.x;
      
      dz = mug[y].P2.z - mug[y].P1.z;
      sz = SGN(dz);
      dz *= sz;
      z  = mug[y].P1.z;

      dc = mug[y].P2.c - mug[y].P1.c;
      sc = SGN(dc);
      dc *= sc;
      c = mug[y].P1.c;  

      if(!dx)
	 {
	 if(z > *z_ptr)  
	   {
	   *graph_ptr = *(unsigned char *)c;
	   *z_ptr = z;
	   }
         continue;
         }


      ez = (dz << 1) - dx;
      ec = (dc << 1) - dx;  

      for(i=0; i<=dx; i++)
	{
	if(z > *z_ptr)
	   {
           *graph_ptr = *(unsigned char *)c;
	   *z_ptr     = z;
	   }

	while(ez > 0)
	  {
	  z += sz;
	  ez -= (dx << 1);
	  }

	while(ec > 0)
	    {
	    c += sc;
	    ec -= (dx << 1);
	    } 

	graph_ptr++;
	z_ptr++;
	ez += (dz << 1);
	ec += (dc << 1);  
	}
     }
   }


void DrawPoly(direct_polygon *Po)
   {
   ClipPoly(Po);
   __DrawPoly();
   }
   
void FillPoly(direct_polygon *Po)
   {
   ClipPoly(Po);
   __FillPoly();
   }

void ShadePoly(direct_polygon *Po)
   {
   ClipPoly(Po);
   __ShadePoly();
   }

void ShadePoly_dither(direct_polygon *Po)
   {
   ClipPoly(Po);
   __ShadePoly_dither();
   }

polyfun P_DRAW_MODE         = __DrawWhitePoly;
polyfun P_DRAW_COLOR_MODE   = __DrawPoly;
polyfun P_FILL_MODE         = __FillWhitePoly;
polyfun P_FILL_COLOR_MODE   = __FillPoly;
polyfun P_SHADE_MODE        = __ShadePoly;
polyfun P_SHADE_DITHER_MODE = __ShadePoly_dither;
polyfun P_ZBUFF_MODE        = __ZBuffPoly;
polyfun P_ZBUFF_SHADE_MODE  = __ZBuffShadePoly;
