/*
 *
 * gl_2d.h
 *
 */

#ifndef GL_2D_H
#define GL_2D_H

#include "gl_clip2d.h"

#define Z_SHIFT 5

#define GL_HUGE 2000000000

#define GM_NONE    0
#define GM_CLIP    1
#define GM_FILL    2
#define GM_DITHER  4 
#define GM_ZBUFF   8
#define GM_GOURAUD 16
#define GM_TEXMAP  32
#define GM_CLOSED  64

typedef void (*polyfun)();

typedef struct
   {
   void (*Pixel)();
   void (*Line)();
   void (*Poly)();
   } g_proc;


typedef struct
   {
   Pixel P1;
   Pixel P2;
   int   init;
   } Mug;

#ifndef GL_2D_C
extern Mug  *mug;
extern int  _draw_mode;
extern polyfun P_DRAW_MODE;
extern polyfun P_DRAW_COLOR_MODE;
extern polyfun P_FILL_MODE;
extern polyfun P_FILL_COLOR_MODE;
extern polyfun P_SHADE_MODE;
extern polyfun P_SHADE_DITHER_MODE;
extern polyfun P_ZBUFF_MODE;
extern polyfun P_ZBUFF_SHADE_MODE;
#endif

void DrawRect  PRM((Rect *r, int c));

void SetPixel  PRM((int x, int y, int c));
void Line      PRM((int x1, int y1, int x2, int y2, int c));

void DrawPoly         PRM((direct_polygon *Po));
void FillPoly         PRM((direct_polygon *Po));
void ShadePoly        PRM((direct_polygon *Po));
void ShadePoly_dither PRM((direct_polygon *Po));

void DitherOn  PRM(());
void DitherOff PRM(());



#endif
