/*
 *
 * gl_clip2d.c
 *
 */

#define GL_CLIP2D_C

#include "gl_clip2d.h"

Pixel Origin = {0, 0};

int _clip_mode = CM_FLAT;

indirect_polygon _poly1, _poly2;
direct_polygon   _pixel_pool;



Rect Clip = {0, 0, D_WIDTH - 1, D_HEIGHT - 1};

void SetClipMode(clipmode)

     int clipmode;

{
  _clip_mode = clipmode;
}

int GetClipMode()
{
  return _clip_mode;
}

void SetClip(x1,y1,x2,y2)

     int x1,y1,x2,y2;

{
  Clip.x1 = x1;
  Clip.y1 = y1;
  Clip.x2 = x2;
  Clip.y2 = y2;
}

void GetClip(x1,y1,x2,y2)

     int *x1,*y1,*x2,*y2;

{
  *x1 = Clip.x1;
  *y1 = Clip.y1;
  *x2 = Clip.x2;
  *y2 = Clip.y2;
}



void SetOrigin(x0, y0)

     int x0,y0;

{
  Origin.x = x0;
  Origin.y = y0;
}

void TranslateOrigin(dx, dy)

     int dx,dy;

{
  Origin.x += dx;
  Origin.y += dy;
}

void GetOrigin(x0, y0)

     int *x0, *y0;

{
  *x0 = Origin.x;
  *y0 = Origin.y;
}


void printp(P)
indirect_polygon *P;
{
int i;
printf("num pts=%d\n",P->npv2);

for(i=0; i<P->npv2; i++)
  {
  printf("%d> x=%d y=%d\n",i,P->pv2[i]->x, P->pv2[i]->y);
  }
}


void _no_clip(Po)
     
     direct_polygon *Po;

{
  int i;

  _poly1.npv2 = 0;

  for(i=0; i<Po->nv2; i++)
    {
    Po->v2[i].status = PS_NONE;  
    v2_push(&_poly1,&(Po->v2[i]));
    Po->v2[i].x += Origin.x;
    Po->v2[i].y += Origin.y;
    }
}


/*
 *
 * here is the big stuff :
 * Sutherland-Hodgman polygon clipping
 *
 */

void _do_clip()

{
  int i,j;
  int flag, old_flag;
  Pixel *S, *P, *I;


  _pixel_pool.nv2 = 0;

/* --------------- clip with x = Clip.x1 ---------------- */

  S = _poly1.pv2[0];
  old_flag = S->x < Clip.x1;
  _poly2.npv2 = 0;

  for(i=1; i<=_poly1.npv2; i++)
    {
      j = i < _poly1.npv2 ? i : 0;
      P = _poly1.pv2[j];
      flag = P->x < Clip.x1;

      if(flag ^ old_flag)
	{
	I = v2_alloc();
	I->status = PS_CLIP;

        I->x = Clip.x1;
        I->y = S->y + (long)(Clip.x1 - S->x) * (P->y - S->y) / (P->x - S->x);

        if(_clip_mode & CM_COLOR)
          {
	  I->c = S->c + (long)(Clip.x1 - S->x) * (P->c - S->c) / (P->x - S->x);
          }

	if(_clip_mode & CM_TEXEL)
	  {
	  I->X = S->X + (long)(Clip.x1 - S->x) * (P->X - S->X) / (P->x - S->x);
	  I->Y = S->Y + (long)(Clip.x1 - S->x) * (P->Y - S->Y) / (P->x - S->x);
	  }

	if(_clip_mode & CM_Z)
	  {
	  I->z = S->z + (long)(Clip.x1 - S->x) * (P->z - S->z) / 
	    (long)(P->x - S->x);
	  }

          v2_push(&_poly2,I);
	}

      if(!flag)
	v2_push(&_poly2,P);

      S = P;
      old_flag = flag;
    }


/* --------------- clip with x = Clip.x2 ---------------- */

  S = _poly2.pv2[0];
  old_flag = S->x > Clip.x2;
  _poly1.npv2 = 0;

  for(i=1; i<=_poly2.npv2; i++)
    {
      j = i < _poly2.npv2 ? i : 0;
      P = _poly2.pv2[j];
      flag = P->x > Clip.x2;

      if(flag ^ old_flag)
	{
	I = v2_alloc();
	I->status = PS_CLIP;

	I->x = Clip.x2;
	I->y = P->y - (long)(P->x - Clip.x2) * (P->y - S->y) / (P->x - S->x);

	if(_clip_mode & CM_COLOR)
          {
	  I->c = P->c - (long)(P->x - Clip.x2) * (P->c - S->c) / (P->x - S->x);
          }

	if(_clip_mode & CM_TEXEL)
	  {
	  I->X = P->X - (long)(P->x - Clip.x2) * (P->X - S->X) / (P->x - S->x);
	  I->Y = P->Y - (long)(P->x - Clip.x2) * (P->Y - S->Y) / (P->x - S->x);
	  }

	if(_clip_mode & CM_Z)
	  {
	  I->z = P->z - (long)(P->x - Clip.x2) * (P->z - S->z) / 
	    (long)(P->x - S->x);
	  }

          v2_push(&_poly1,I);
	}

      if(!flag)
	v2_push(&_poly1,P);

      S = P;
      old_flag = flag;
    }

/* --------------- clip with y = Clip.y1 ---------------- */

  S = _poly1.pv2[0];
  old_flag = S->y < Clip.y1;
  _poly2.npv2 = 0;

  for(i=1; i<=_poly1.npv2; i++)
    {

      j = i < _poly1.npv2 ? i : 0;


      P = _poly1.pv2[j];
      flag = P->y < Clip.y1;

      if(flag ^ old_flag)
	{
	
	I = v2_alloc();
        I->status = PS_CLIP;

        I->y = Clip.y1;
        I->x = S->x + (long)(Clip.y1 - S->y) * (P->x - S->x) / (P->y - S->y);

        if(_clip_mode & CM_COLOR)
          {
	  I->c = S->c + (long)(Clip.y1 - S->y) * (P->c - S->c) / (P->y - S->y);
          }

	if(_clip_mode & CM_TEXEL)
	  {
	  I->X = S->X + (long)(Clip.y1 - S->y) * (P->X - S->X) / (P->y - S->y);
	  I->Y = S->Y + (long)(Clip.y1 - S->y) * (P->Y - S->Y) / (P->y - S->y);
	  }

	if(_clip_mode & CM_Z)
	  {
	  I->z = S->z + (long)(Clip.y1 - S->y) * (P->z - S->z) / 
	    (long)(P->y - S->y);
	  }

          v2_push(&_poly2,I);
	}

      if(!flag)
	v2_push(&_poly2,P);

      S = P;
      old_flag = flag;
    }

/* --------------- clip with y = Clip.y2 ---------------- */

  S = _poly2.pv2[0];
  old_flag = S->y > Clip.y2;
  _poly1.npv2 = 0;

  for(i=1; i<=_poly2.npv2; i++)
    {
      j = i < _poly2.npv2 ? i : 0;
      P = _poly2.pv2[j];
      flag = P->y > Clip.y2;

      if(flag ^ old_flag)
	{
	I = v2_alloc();
	I->status = PS_CLIP;

	I->y = Clip.y2;
	I->x = P->x - (long)(P->y - Clip.y2) * (P->x - S->x) / (P->y - S->y);

	if(_clip_mode & CM_COLOR)
          {
	  I->c = P->c - (long)(P->y - Clip.y2) * (P->c - S->c) / (P->y - S->y);
          }

	if(_clip_mode & CM_TEXEL)
	  {
	  I->X = P->X - (long)(P->y - Clip.y2) * (P->X - S->X) / (P->y - S->y);
	  I->Y = P->Y - (long)(P->y - Clip.y2) * (P->Y - S->Y) / (P->y - S->y);
	  }

	if(_clip_mode & CM_Z)
	  {
	  I->z = P->z - (long)(P->y - Clip.y2) * (P->z - S->z) / 
	    (long)(P->y - S->y);
	  }

          v2_push(&_poly1,I);
	}

      if(!flag)
	v2_push(&_poly1,P);

      S = P;
      old_flag = flag;
    }
}

void ClipPoly(direct_polygon *Po)
{
  _no_clip(Po);
  if(_clip_mode)
  _do_clip();
}

void _ClipPoly(indirect_polygon *Po)
{
  _poly1 = *Po;
  _do_clip();
}
