
/*
 *
 * gl_clip2d.h
 *
 */

#ifndef GL_CLIP2D_H
#define GL_CLIP2D_H

#include "framebuff.h"

#define PS_NONE 0
#define PS_CLIP 1

typedef struct
   {
   int   x,y;    /* screen coordinates                      */
   int   c;      /* colormap index                          */
   int   X,Y;    /* texture space coordinates               */
   long  z;     /* z coord in clip space (for z-buffering) */ 
   int status; /* pixel information                       */
   } Pixel;

typedef struct
   {
   int x1, y1, x2, y2;
   } Rect;

#define InRect(r,x,y) ( (x) >= (r)->x1 && (y) >= (r)->y1 && \
		        (x) <= (r)->x2 && (y) <= (r)->y2    )




void SetClip     PRM((int x1, int y1, int x2, int y2));
void GetClip     PRM((int *x1, int *y1, int *x2, int *y2));
void SetClipMode PRM((int clipmode));
int  GetClipMode PRM(());

void SetOrigin       PRM((int  x0, int  y0));
void GetOrigin       PRM((int *x0, int *y0));
void TranslateOrigin PRM((int  dx, int  dy));

#define CM_NONE  0
#define CM_FLAT  1
#define CM_COLOR 2
#define CM_TEXEL 4
#define CM_Z     8

#define N_V2      512
#define N_PV2     512

typedef struct
{
  int   npv2;
  Pixel *pv2[N_PV2];
} indirect_polygon;

typedef struct
{
  int nv2;
  Pixel v2[N_V2];
} direct_polygon;

void  ClipPoly PRM((direct_polygon   *Po));
void _ClipPoly PRM((indirect_polygon *Po));

#define v2_push(p,v) ((p)->pv2[(p)->npv2++] = (v))
#define v2_alloc()   &(_pixel_pool.v2[_pixel_pool.nv2++])

#ifndef GL_CLIP2D_C
extern int _clip_mode;
extern indirect_polygon _poly1;
extern Rect  Clip;
extern Pixel Origin;
#endif


#endif





