

/*
 *
 * gl_obj.c
 * 
 */


#include "gl_obj.h"


FILE *yyin;
int fini;

extern dbl lval;

dbl get_dbl()
   {
     dbl f;
     if(!yylex())
       {
/*	 fprintf(stderr,"get_dbl(): unexpected end of file\n"); */
	 fini = 1;
	 return 0.0;
/*	 exit(1);  */
       }
     return lval;
   }


int get_int()
   {
     return (int)get_dbl();
   }



Mesh *gl_read_3DG1(char *filename, long R)
  {
    Mesh    *result;
    VectorF *vertex;
    int     nvertex;
    char dummy[300];
    int  avail_faces;
    int  nblock;
    int  i;
    VectorF C;
    dbl k,r2,r3,r = R;

    if(!(yyin = fopen(filename,"r")))
      {
	fprintf(stderr,"gl_read(): could not open %s\n",filename);
	exit(1);
      }

    result = NEW(Mesh);
    result->mode    = M_KAOS;

    /* ------------------- vertices ----------------- */

    nvertex = get_int();
    printf("nvertex = %d\n",nvertex);

    vertex = NEWARRAY(VectorF,nvertex);
    for(i=0; i<nvertex; i++)
      {
	vertex[i].x = get_dbl();
	vertex[i].y = get_dbl();
	vertex[i].z = get_dbl();
      }

    result->vertex  = NEWARRAY(Vector,nvertex);
    result->proj    = NEWARRAY(Pixel, nvertex);
    result->nvertex = nvertex; 
    
    /* ------------------- faces ----------------- */

    result->nfaces   = 0;
    result->face     = NEWARRAY(Face, FACE_BLOCK);
    avail_faces = FACE_BLOCK;
    nblock      = 1;

    fini = 0;

    while(!fini)
      {
	if(!avail_faces)
	  {
	    nblock++;
	    result->face = (Face *)realloc(result->face, 
				       FACE_BLOCK * nblock * sizeof(Face));
	    avail_faces = FACE_BLOCK;
	  }
	result->face[result->nfaces].npts = get_int();
	for(i=0; i<result->face[result->nfaces].npts; i++)
	  result->face[result->nfaces].pts[i] = get_int();

	(void)get_int();

	result->nfaces++;
	avail_faces--;
      }

    /* ------------------ center & scale ------------------- */

    printf("center & scale\n");

    SetVector(&C,0.0,0.0,0.0);
    for(i=0; i<nvertex; i++)
      {
	C.x += vertex[i].x;
	C.y += vertex[i].y;
	C.z += vertex[i].z;
      }

    k = nvertex;
    k = k ? 1.0 / k : 0;
    ScaleVector(&C,k);

    r2 = 0;
    for(i=0; i<nvertex; i++)
      {
	vertex[i].x -= C.x;
	vertex[i].y -= C.y;
	vertex[i].z -= C.z;
	r3 = NORM2(&(vertex[i]));
	r3 = sqrt(r3);
	r2 = MAX(r2,r3);
      }

    k = r2 ? r / r2 : 0.0;

    for(i=0; i<nvertex; i++)
      {
	ScaleVector(&(vertex[i]),k);
      }

    /* ------------ convert to TAGL Mesh ----------- */

    printf("convert to TAGL Mesh\n");

    for(i=0; i<nvertex; i++)
      {
	result->vertex[i].x = (int)vertex[i].x;
	result->vertex[i].y = (int)vertex[i].y;
	result->vertex[i].z = (int)vertex[i].z;
      }

    free(vertex);

    fclose(yyin);
    
    printf("call ComputeNormals()\n");

    ComputeNormals(result);

    printf("sucessfully loaded\n");

    return result;
  }



Mesh *gl_read_geo(char *filename, long R)
  {
    Mesh    *result;
    VectorF *vertex;
    int     nvertex;
    int  i,j,npts;
    VectorF C;
    dbl k,r2,r3,r = R;

    if(!(yyin = fopen(filename,"r")))
      {
	fprintf(stderr,"gl_read(): could not open %s\n",filename);
	exit(1);
      }

    result = NEW(Mesh);
    result->mode    = M_KAOS;

    /* ------------------- vertices ----------------- */

    nvertex = get_int();
    result->nvertex  = nvertex;
    result->nfaces   = get_int();

    (void) get_int();

    printf("nvertex = %d\n",nvertex);
    printf("nface   = %d\n",result->nfaces);

    vertex = NEWARRAY(VectorF,nvertex);
    for(i=0; i<nvertex; i++)
      {
	vertex[i].x = get_dbl();
	vertex[i].y = get_dbl();
	vertex[i].z = get_dbl();

      }

    result->vertex  = NEWARRAY(Vector,nvertex);
    result->proj    = NEWARRAY(Pixel, nvertex);
    result->nvertex = nvertex; 
    
    /* ------------------- faces ----------------- */


    result->face     = NEWARRAY(Face, result->nfaces);

    for(i=0; i < result->nfaces; i++)
      {
	npts = get_int();
	result->face[i].npts = npts;
	for(j=0; j < npts; j++)
	  result->face[i].pts[npts - j - 1] = get_int() - 1;
      }

    /* ------------------ center & scale ------------------- */

    printf("center & scale\n");

    SetVector(&C,0.0,0.0,0.0);
    for(i=0; i<nvertex; i++)
      {
	C.x += vertex[i].x;
	C.y += vertex[i].y;
	C.z += vertex[i].z;
      }

    k = nvertex;
    k = k ? 1.0 / k : 0;
    ScaleVector(&C,k);

    printf("Center [%f %f %f]\n",C.x,C.y,C.z);

    r2 = 0;
    for(i=0; i<nvertex; i++)
      {
	vertex[i].x -= C.x;
	vertex[i].y -= C.y;
	vertex[i].z -= C.z;

	r3 = NORM2(&(vertex[i]));
	r3 = sqrt(r3);

	r2 = MAX(r2,r3);
      }

    printf("object radius = %f\n",r2);

    k = r2 ? r/r2 : 0;

    printf("scaling factor: %f\n",k);

    printf("R = %ld\n",R);

    for(i=0; i<nvertex; i++)
      {
	ScaleVector(&(vertex[i]),k);
      }

    /* ------------ convert to TAGL Mesh ----------- */

    printf("convert to TAGL Mesh\n");

    for(i=0; i<nvertex; i++)
      {
	result->vertex[i].x =     (int)vertex[i].z;
	result->vertex[i].y =   - (int)vertex[i].y;
	result->vertex[i].z =     (int)vertex[i].x;
      }

    free(vertex);

    fclose(yyin);
    
    printf("call ComputeNormals()\n");

    ComputeNormals(result);

    printf("sucessfully loaded\n");

    return result;
  }



