/*
 *
 * a clone of the mars demo
 * under TAGL
 *
 */

/* Gouraud shading functions */
#include "gl_2d.h"
#include <math.h>

/*
 * For data struct defs
 * Lighting model and
 * projection stuff
 * are coded internally
 *
 */

#include "gl_3d.h"

#define MARS_SZ  32768
#define MARS_BND (MARS_SZ >> 1)
   
void mars_Project(V, Voff, P)
     
     Vector *V, *Voff;
     Pixel  *P;

{
   long x = (Voff->x + V->x) << 1;
   long y = Voff->y + V->y;
   long z = D_HEIGHT - 
            ((Voff->z + V->z) * ((D_HEIGHT >> 1) + 
		     (D_HEIGHT >> 2)) / MARS_SZ);

#ifdef D_HIRES
#else
#endif

   P->x = (x * z) / MARS_SZ + (D_WIDTH  >> 1);
   P->y = (y * z) / MARS_SZ + (D_HEIGHT >> 1);
   P->z = V->z;


   P->c = 63 - (P->z >> 9);

   P->c = P->c < 0 ? 0 : P->c;

}

Vector Null  = {0,0,0};
Vector Voff1 = {-MARS_BND,0,0};
Vector Voff2 = { MARS_BND,0,0};

int off_x, off_y;


int fnc(int x, int y)
{
  long xr, yr, zr;
  xr = x /* + off_x */;
  yr = y /* + off_y */;
  zr = (1 << 14) + SIN(xr >> 6)*COS(yr >> 6);
  zr = zr >> 17;
  zr += (zr >> 1);
  return zr;
}


#define STP 2048

void mars_Draw()
{
  Vector V;
  Pixel  P1, P2, P3, P4;
  long x,y;
  dbl  xr,yr,zr;

  graph_clear(6);


    for(y = MARS_SZ; y > - (MARS_SZ >> 4); y -= STP)
      for(x = - MARS_BND * 1.25; x < MARS_BND * 1.25; x += STP)

      {

	V.x = x;
	V.z = y;
	V.y = MARS_BND - fnc(x,y);
	mars_Project(&V, &Null,  &P1);

	V.x = x + STP;
	V.z = y;
	V.y = MARS_BND - fnc(x+STP,y);
	mars_Project(&V, &Null,  &P2);	

	V.x = x + STP;
	V.z = y + STP;
	V.y = MARS_BND - fnc(x+STP,y+STP);
	mars_Project(&V, &Null,  &P3);	

	V.x = x;
	V.z = y + STP;
	V.y = MARS_BND - fnc(x,y+STP);
	mars_Project(&V, &Null,  &P4);	

	_poly1.npv2 = 0;
	v2_push(&_poly1,&P1);
	v2_push(&_poly1,&P2);
	v2_push(&_poly1,&P3);
	v2_push(&_poly1,&P4);
	
	_do_clip();

	P_SHADE_MODE(); 
      }
  graph_swap();
}


int gl_valuator(wx, wy)
int *wx, *wy;
{
int gl_locator PRM((int *, int *));

return gl_locator(wx,wy);

}

void main()
{
  int btn;
  char dummy;
  OpenS();
  SetClipMode(CM_COLOR);
  while(!readkbd(&dummy))
    {
    btn = gl_valuator(&off_x,&off_y);  
    off_x -= (D_WIDTH  >> 1);
    off_y -= (D_HEIGHT >> 1);
    off_x *= 100;
    off_y *= 100;
    Null.x = off_x;
    Null.y = btn ? off_y : 0;
    Null.z = btn ? 0     : off_y;
    mars_Draw();
    }
}

