char *R_Title = "3D object viewer";
char *S_Title = "rot";

#include "raster.h"
#include "sliders.h"

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <signal.h>

#define W  500
#define H  500
#define D  100


#define HP 300
#define padx 50
#define pady 50

#define c_x1 -1.0
#define c_x2  1.0
#define c_y1 -1.0
#define c_y2  1.0
#define c_z1 -1.0
#define c_z2  1.0


#define MIN(x,y) ((x) < (y) ? (x) : (y))
#define MAX(x,y) ((x) > (y) ? (x) : (y))
#define SQR(x)   ((x)*(x))
#define ABS(x)   MAX(x,0)


#define Face_Block   256

typedef struct
{
  double x,y,z;
} Vertex;

typedef struct
   {
   int P1,P2,P3;  
   double x;
   int color;
   } Face;

typedef struct
   {
   int nvertex, nface;
   Face   *face;
   Vertex *vertex;
   int    *index;
   } Mesh;


Mesh *TheMesh;

Mesh *Read3DG1(FileName)

   char *FileName;

   {
   FILE *f = fopen(FileName,"r");
   Mesh *m = (Mesh *)malloc(sizeof(Mesh));
   float x,y,z;
   char Dummy[300];
   int  DummyInt;
   int  i;
   int  AvailableFaces = 0;
   int  nalloc = 0;
   double Cx = 0,Cy = 0,Cz = 0;
   double R = 0, tR;
   
   if(!f) 
     {
     printf("big problem !!\n");  
     return NULL;
     }


   fscanf(f,"%s",Dummy);

   fscanf(f,"%d",&(m->nvertex));
   m->nface   = 0;

   m->vertex = (Vertex *)malloc(m->nvertex * sizeof(Vertex));
   m->face   = (Face   *)malloc(Face_Block * sizeof(Face  ));
   AvailableFaces = Face_Block;
   nalloc++;
   
   for(i=0; i < m->nvertex; i++)
     {
     fscanf(f,"%f%f%f",&x,&y,&z);
     m->vertex[i].x = x;
     m->vertex[i].y = y;
     m->vertex[i].z = z;
     Cx += x;
     Cy += y;
     Cz += z;
     }

   Cx /= m->nvertex;
   Cy /= m->nvertex;
   Cz /= m->nvertex;

   for(i=0; i < m->nvertex; i++)
     {
     m->vertex[i].x -= Cx;
     m->vertex[i].y -= Cy;
     m->vertex[i].z -= Cz;
    
     tR = sqrt(SQR(m->vertex[i].x)+SQR(m->vertex[i].y)+SQR(m->vertex[i].z));
     R = MAX(R,tR);
     }

   for(i=0; i < m->nvertex; i++)
     {
     m->vertex[i].x /= R;
     m->vertex[i].y /= R;
     m->vertex[i].z /= R;
     }

   while(!feof(f))
     {
     (m->nface)++;  
     fscanf(f,"%d%d%d%d%d",&DummyInt,
                &(m->face[m->nface-1].P1),
                &(m->face[m->nface-1].P2),
                &(m->face[m->nface-1].P3),
                &(m->face[m->nface-1].color));  
     if((m->nface == AvailableFaces) && !feof(f))
       {
       nalloc++;	 
       m->face = (Face *)realloc(m->face, nalloc * Face_Block * sizeof(Face));
       AvailableFaces += Face_Block;
       }
     }

   (m->nface)--;

   m->index = (int *) malloc((m->nface + 1) * sizeof(int));
   for(i=0; i<m->nface; i++)
     {
     m->face[i].x =  ( m->vertex[m->face[i].P1].x +
                       m->vertex[m->face[i].P1].x +
                       m->vertex[m->face[i].P1].x ) / 3.0;   
     m->index[i+1] = i;
     }

   return m;
   }

/*
void SortMesh(m)

     Mesh *m;

   {
   int i,j,v;
   for(i=0; i<m->nface; i++)
     {
     v = m->index[i];
     j = i;
     while()
     }
   }
*/

#define MIN(x,y) ((x) < (y) ? (x) : (y))
#define MAX(x,y) ((x) > (y) ? (x) : (y))
#define SQR(x)   ((x)*(x))
#define ABS(x)   MAX(x,0)

void OpenBox()
   {
   unsigned long c = HardColor(0,0,255,0,0);
   XSetForeground(R_Display, R_GC, c);

/*
   XDrawLine(R_Display, R_Win, R_GC, padx+0  , pady+HP, padx+W-D, pady+HP  );
   XDrawLine(R_Display, R_Win, R_GC, padx+W-D, pady+HP, padx+W  , pady+H   );
   XDrawLine(R_Display, R_Win, R_GC, padx+W  , pady+H , padx+D  , pady+H   );
   XDrawLine(R_Display, R_Win, R_GC, padx+D  , pady+H , padx+0  , pady+HP  );
   XDrawLine(R_Display, R_Win, R_GC, padx+0  , pady+HP, padx+0  , pady+0   );
   XDrawLine(R_Display, R_Win, R_GC, padx+W-D, pady+HP, padx+W-D, pady+0   );
   XDrawLine(R_Display, R_Win, R_GC, padx+W  , pady+H , padx+W  , pady+H-HP);
   XDrawLine(R_Display, R_Win, R_GC, padx+0  , pady+0 , padx+W-D, pady+0   );
   XDrawLine(R_Display, R_Win, R_GC, padx+W-D, pady+0 , padx+W  , pady+H-HP);
*/

   XDrawLine(R_Display, R_Pixmap, R_GC, padx+0  , pady+HP, padx+W-D, pady+HP  );
   XDrawLine(R_Display, R_Pixmap, R_GC, padx+W-D, pady+HP, padx+W  , pady+H   );
   XDrawLine(R_Display, R_Pixmap, R_GC, padx+W  , pady+H , padx+D  , pady+H   );
   XDrawLine(R_Display, R_Pixmap, R_GC, padx+D  , pady+H , padx+0  , pady+HP  );
   XDrawLine(R_Display, R_Pixmap, R_GC, padx+0  , pady+HP, padx+0  , pady+0   );
   XDrawLine(R_Display, R_Pixmap, R_GC, padx+W-D, pady+HP, padx+W-D, pady+0   );
   XDrawLine(R_Display, R_Pixmap, R_GC, padx+W  , pady+H , padx+W  , pady+H-HP);
   XDrawLine(R_Display, R_Pixmap, R_GC, padx+0  , pady+0 , padx+W-D, pady+0   );
   XDrawLine(R_Display, R_Pixmap, R_GC, padx+W-D, pady+0 , padx+W  , pady+H-HP);



   }

void CloseBox()
   {
   unsigned long c = HardColor(0,0,255,0,0);
   XSetForeground(R_Display, R_GC, c);

/*
   XDrawLine(R_Display, R_Win, R_GC, padx+0, pady+   0,  padx+D, pady+H-HP  );
   XDrawLine(R_Display, R_Win, R_GC, padx+W, pady+H-HP,  padx+D, pady+H-HP  );
   XDrawLine(R_Display, R_Win, R_GC, padx+D, pady+  H ,  padx+D, pady+H-HP  );
*/

   XDrawLine(R_Display, R_Pixmap, R_GC, padx+0, pady+   0, padx+ D, pady+H-HP  );
   XDrawLine(R_Display, R_Pixmap, R_GC, padx+W, pady+H-HP, padx+ D, pady+H-HP  );
   XDrawLine(R_Display, R_Pixmap, R_GC, padx+D, pady+  H , padx+ D, pady+H-HP  );

   }

void Project(x,y,z,XE,YE)

   double x,y,z;
   int *XE, *YE;  
   {
   double Z,Y,Xh,Xv;

   Z  = (1.0 - (z-c_z1) / (c_z2 - c_z1)) * HP;
   Y  = (y-c_y1)/(c_y2 - c_y1) * (W - D);
   Xh = (x-c_x1)/(c_x2-c_x1)*D;
   Xv = (x-c_x1)/(c_x2-c_x1)*(H-HP);
   
   *XE = Xh+Y+padx;
   *YE = Xv+Z+pady;

   }

void Tri(x1,y1,x2,y2,x3,y3,c)

     int x1,y1,x2,y2,x3,y3,c;

   {
   XSetForeground(R_Display, R_GC, c);

/*
   XDrawLine(R_Display, R_Win, R_GC, x1, y1, x2, y2);
   XDrawLine(R_Display, R_Win, R_GC, x2, y2, x3, y3);
   XDrawLine(R_Display, R_Win, R_GC, x3, y3, x1, y1);
*/

   XDrawLine(R_Display, R_Pixmap, R_GC, x1, y1, x2, y2);
   XDrawLine(R_Display, R_Pixmap, R_GC, x2, y2, x3, y3);
   XDrawLine(R_Display, R_Pixmap, R_GC, x3, y3, x1, y1);
   }

void TriGouraud(x1,y1,r1,g1,b1,x2,y2,r2,g2,b2,x3,y3,r3,g3,b3)

     int x1,y1,x2,y2,x3,y3;
     int r1,g1,b1,r2,g2,b2,r3,g3,b3;

     {
     int xmin = MIN(MIN(x1,x2),x3);
     int ymin = MIN(MIN(y1,y2),y3);
     int xmax = MAX(MAX(x1,x2),x3);
     int ymax = MAX(MAX(y1,y2),y3);
     int x,y;
     double alpha, beta, gamma;
     double r,g,b;
     double _a,_b,_c,_d,det;

     for(y=ymin; y<=ymax; y++)
       for(x=xmin; x<=xmax; x++)
	 {

	   _a =  (y3-y1);
	   _b = -(y2-y1);
	   _c = -(x3-x1);
	   _d =  (x2-x1);
	   det = _a*_d-_b*_c;

	   if(!det)
	     continue;

	   _a /= det;
	   _b /= det;
	   _c /= det;
	   _d /= det;
	   

	 beta  = (x-x1) * _a + (y-y1) * _c;
	 gamma = (x-x1) * _b + (y-y1) * _d;
	 alpha = 1.0 - beta - gamma;


	 if((alpha >= 0.0) && (beta >= 0.0) && (gamma >= 0.0))
	   {

	   r = (alpha * r1 + beta * r2 + gamma * r3) / 2;
	   g = (alpha * g1 + beta * g2 + gamma * g3) / 2;
	   b = (alpha * b1 + beta * b2 + gamma * b3) / 2;

	   RasterPutPixel(x,y,(int)r, (int)g, (int)b);
           }
	 }
     }

void RotX(m,angle)

     Mesh *m;
     double angle;

   {
   double s = sin(angle);
   double c = cos(angle);
   double u,v;

   int i;
   
   for(i=0; i<m->nvertex; i++)
     {
     u = m->vertex[i].y *  c + m->vertex[i].z * s;
     v = m->vertex[i].y * -s + m->vertex[i].z * c;

     m->vertex[i].y = u;
     m->vertex[i].z = v;
     }

   }


void RotY(m,angle)

     Mesh *m;
     double angle;

   {
   double s = sin(angle);
   double c = cos(angle);
   double u,v;

   int i;
   
   for(i=0; i<m->nvertex; i++)
     {
     u = m->vertex[i].x *  c + m->vertex[i].z * s;
     v = m->vertex[i].x * -s + m->vertex[i].z * c;

     m->vertex[i].x = u;
     m->vertex[i].z = v;
     }

   }


void RotZ(m,angle)

     Mesh *m;
     double angle;

   {
   double s = sin(angle);
   double c = cos(angle);
   double u,v;

   int i;
   
   for(i=0; i<m->nvertex; i++)
     {
     u = m->vertex[i].x *  c + m->vertex[i].y * s;
     v = m->vertex[i].x * -s + m->vertex[i].y * c;

     m->vertex[i].x = u;
     m->vertex[i].y = v;
     }

   }


void Scale(m,factor)
     
   Mesh   *m;
   double factor;

   {
   int i;  
   for(i=0; i<m->nvertex; i++)
     {
     m->vertex[i].x *= factor;
     m->vertex[i].y *= factor;
     m->vertex[i].z *= factor;
     }
   }


void Line3D(V1,V2,c)

     Vertex *V1,*V2;
     long c;

   {
   int xe1,ye1,xe2,ye2;
   double vx = V2->x - V1->x;
   double vy = V2->y - V1->y;
   double vz = V2->z - V1->z;
   double t;
   Vertex v1 = *V1; 
   Vertex v2 = *V2;

   if(v1.x < -1 )
     { 
     if(!vx) return;
     t = -(v1.x + 1.0)/vx; v1.x += t*vx; v1.y += t*vy; v1.z += t*vz; 
     }

   if(v1.y < -1 )
     { 
     if(!vy) return;
     t = -(v1.y + 1.0)/vy; v1.x += t*vx; v1.y += t*vy; v1.z += t*vz; 
     }

   if(v1.z < -1 )
     {
     if(!vz) return;  
     t = -(v1.z + 1.0)/vz; v1.x += t*vx; v1.y += t*vy; v1.z += t*vz; 
     }


   if(v1.x >  1 )
     {
     if(!vx) return;  
     t = -(v1.x - 1.0)/vx; v1.x += t*vx; v1.y += t*vy; v1.z += t*vz; 
     }

   if(v1.y >  1 )
     {
     if(!vy) return;  
     t = -(v1.y - 1.0)/vy; v1.x += t*vx; v1.y += t*vy; v1.z += t*vz; 
     }

   if(v1.z >  1 )
     { 
     if(!vz) return;  
     t = -(v1.z - 1.0)/vz; v1.x += t*vx; v1.y += t*vy; v1.z += t*vz; 
     }

   if(v2.x < -1 )
     {
     if(!vx) return;  
     t = -(v2.x + 1.0)/vx; v2.x += t*vx; v2.y += t*vy; v2.z += t*vz; 
     }

   if(v2.y < -1 )
     {
     if(!vy) return;  
     t = -(v2.y + 1.0)/vy; v2.x += t*vx; v2.y += t*vy; v2.z += t*vz; 
     }

   if(v2.z < -1 )
     {
     if(!vz) return;  
     t = -(v2.z + 1.0)/vz; v2.x += t*vx; v2.y += t*vy; v2.z += t*vz; 
     }


   if(v2.x >  1 )
     {
     if(!vx) return;  
     t = -(v2.x - 1.0)/vx; v2.x += t*vx; v2.y += t*vy; v2.z += t*vz; 
     }

   if(v2.y >  1 )
     {
     if(!vy) return;  
     t = -(v2.y - 1.0)/vy; v2.x += t*vx; v2.y += t*vy; v2.z += t*vz; 
     }

   if(v2.z >  1 )
     {
     if(!vz) return;  
     t = -(v2.z - 1.0)/vz; v2.x += t*vx; v2.y += t*vy; v2.z += t*vz; 
     }



   Project(v1.x, v1.y, v1.z, &xe1, &ye1);
   Project(v2.x, v2.y, v2.z, &xe2, &ye2);
  
   XSetForeground(R_Display, R_GC, c);

/*   XDrawLine(R_Display, R_Win,    R_GC, xe1, ye1, xe2, ye2); */
   XDrawLine(R_Display, R_Pixmap, R_GC, xe1, ye1, xe2, ye2);

   }
     

void DrawMesh(m)

     Mesh *m;

   {
   int color,i;

   RasterBackClear();
   OpenBox();

   color = HardColor(0,0,200,200,200);

   for(i=0; i<m->nface; i++)
     {
     Line3D(&(m->vertex[m->face[i].P1]),
            &(m->vertex[m->face[i].P2]),
            color);  

     Line3D(&(m->vertex[m->face[i].P2]),
            &(m->vertex[m->face[i].P3]),
	    color);  

     Line3D(&(m->vertex[m->face[i].P3]),
            &(m->vertex[m->face[i].P1]),
	    color);  

     }

   CloseBox();
   RefreshRasterScreen();

   XFlush(R_Display);

   }



void main(argc, argv)
   int argc;
   char **argv;  

   {

   XEvent TheEvent;  

   signal(SIGFPE,SIG_IGN);

   if(argc != 2)
     {
     fprintf(stderr,"objview: file name expected\n");
     exit(-1);
     }

   TheMesh = Read3DG1(argv[1]);

   OpenRasterScreen(W+(padx<<1),H+(pady<<1),R_D8);  
   InitSliders();

   DrawMesh(TheMesh); 

   while(R_running)
     {
     XNextEvent(R_Display, &TheEvent);  
     
     RasterHandleEvent(&TheEvent);

     if(SlidersHandleEvent(&TheEvent))
       {
	 
       if(delta1)
	 RotX(TheMesh,(double)delta1/100.0);

       if(delta2)
	 RotY(TheMesh,(double)delta2/100.0);

       if(delta3)
	 RotZ(TheMesh,(double)delta3/100.0);

       if(delta4)
	 Scale(TheMesh,(double)pos4/(double)(pos4 + delta4));

       DrawMesh(TheMesh);

       }
     }

   }



