
#include "framebuff.h"
#include "gl_clip2d.h"
#include "gl_3d.h"
#include <time.h>

#define now() time(NULL)

int dither = 0;
int help   = 0;
direct_polygon P;
long nframe = 0;
int tinit;

int mode  = 0;
int nmode = 4; 

int obj  = 4;
int nobj = 6;

Node *object[50];

void InitColormap()
{
int i;
/*
for(i=0; i<64; i++)
   SetRGB(i,i,i,i);
 */
}

int BD = 20;
int T  = 10;

void Help(x,y)
   {
   Rect r,rr;
   char stats[300];
   long elapsed = now() - tinit;

   elapsed = elapsed ? elapsed : 1;

   r.x1 = x-20;       r.y1 = y-20;
   r.x2 = r.x1 + 240; r.y2 = r.y1+140;
   rr = Clip;
   Clip = r;

   sprintf(stats,"f %5d t %4d ft %3d",nframe, elapsed, nframe/elapsed);

   gl_string("TAGL 3D shaded vector ",x,y    ,63);
   gl_string("rotate X         1-4-7",x,y+10 ,63);
   gl_string("rotate Y         2-5-8",x,y+20 ,63);
   gl_string("rotate Z         3-6-9",x,y+30 ,63);
   gl_string("stop             0    ",x,y+40 ,63);
   gl_string("toggle dither    d    ",x,y+50 ,63);
   gl_string("enlarge window   a    ",x,y+60 ,63);
   gl_string("shrink window    z    ",x,y+70 ,63);
   gl_string("zoom in-out      + -  ",x,y+80 ,63);
   gl_string("toggle help      h    ",x,y+90 ,63);
   gl_string("quit             q    ",x,y+100,63);
   gl_string(stats,x,y+110,63);

   DrawRect(&r,63);

   Clip = rr;
   }

Node *InitObj1()
   {
   Mesh *m1, *m2;
   Node *n1, *n2, *n;
   Link *l1, *l2, *l;
   Vector V1,V2,T,V;

   SetVector(&V1,-2000,-2000,-2000);
   SetVector(&V2, 2000, 2000, 2000);

   m1 = MakeBox(&V1, &V2, 1);
   m2 = MakeBox(&V1, &V2, 1);

   SetVector(&T,3000,0,0);
   TranslateMesh(m1,&T);
   SetVector(&T,-3000,0,0);
   TranslateMesh(m2,&T);
   n1 = Mesh2Node(m1);
   n2 = Mesh2Node(m2);

   SetVector(&V,15000,0,0)
   l1 = MakeLink(n1,n2,&V);

   n1 = Link2Node(l1);
   n2 = NodeCpy(n1);

   SetVector(&T,0,3000,0);
   TranslateNode(n1,&T);
   SetVector(&T,0,-3000,0);
   TranslateNode(n2,&T);

   SetVector(&V,0,15000,0)
   l1 = MakeLink(n1,n2,&V);

   n1 = Link2Node(l1);
   n2 = NodeCpy(n1);

   SetVector(&T,0,0,3000);
   TranslateNode(n1,&T);
   SetVector(&T,0,0,-3000);
   TranslateNode(n2,&T);
   
   SetVector(&V,0,0,15000)
   l  = MakeLink(n1,n2,&V);
   n  = Link2Node(l);

   return n;
   }

Node *InitObj2(int convex)
   {
   Mesh *m1, *m2;
   Node *n1, *n2, *n;
   Link *l1, *l2, *l;
   Vector V1,V2,T,V;

   SetVector(&V1,-2000,-2000,-2000);
   SetVector(&V2, 2000, 2000, 2000);

   m1 = MakeBox(&V1, &V2, convex);

   SetVector(&V1,-1000,-1000,-1000);
   SetVector(&V2, 1000, 1000, 1000);

   m2 = MakeBox(&V1, &V2, convex);

   SetVector(&T,3000,0,0);
   TranslateMesh(m1,&T);
   SetVector(&T,-3000,0,0);
   TranslateMesh(m2,&T);
   n1 = Mesh2Node(m1);
   n2 = Mesh2Node(m2);

   SetVector(&V,15000,0,0)
   l1 = MakeLink(n1,n2,&V);

   n1 = Link2Node(l1);
   n2 = NodeCpy(n1);

   RotNode(n2,'z',128);

   SetVector(&T,0,3000,0);
   TranslateNode(n1,&T);
   SetVector(&T,0,-3000,0);
   TranslateNode(n2,&T);

   SetVector(&V,0,15000,0)
   l1 = MakeLink(n1,n2,&V);

   n1 = Link2Node(l1);
   n2 = NodeCpy(n1);

   RotNode(n2,'y',128);

   SetVector(&T,0,0,3000);
   TranslateNode(n1,&T);
   SetVector(&T,0,0,-3000);
   TranslateNode(n2,&T);
   
   SetVector(&V,0,0,15000)
   l  = MakeLink(n1,n2,&V);
   n  = Link2Node(l);

   return n;
   }

Node *InitObj3()
   {
     Mesh *m = MakeCone(1000,3000,7000,4,0);
     SmoothMesh(m);
     return Mesh2Node(m);
   }

Node *InitObj4()
   {
   Mesh *m1, *m2, *m3, *m4;
   Node *n, *n1, *n2, *n3, *n4;
   Link *l1, *l2, *l;
   Vector V1,V2,T,V;

   SetVector(&V1,-2000,-2000,-2000);
   SetVector(&V2, 2000, 2000, 2000);

   m1 = MakeBox(&V1,  &V2, 1);
   m3 = MeshCpy(m1);
   m2 = MakeCyl(1000, 4000, 4, 0);
   m2->mode |= M_CONVEX;
   SmoothMesh(m2);

   SetVector(&T,0,0,4000);
   TranslateMesh(m1,&T);

   n1 = Mesh2Node(m1);
   n2 = Mesh2Node(m2);
   
   SetVector(&V,0,0,GL_BIG);
   l = MakeLink(n1,n2,&V);
   n1 = Link2Node(l);

   SetVector(&T,0,0,-4000);
   TranslateMesh(m3,&T);
   n2 = Mesh2Node(m3);
   
   SetVector(&V,0,0,GL_BIG);
   l = MakeLink(n1,n2,&V);
   n1 = Link2Node(l);
   n2 = NodeCpy(n1);

   SetVector(&T, 4000,0,0);
   TranslateNode(n1,&T);
   SetVector(&T,-4000,0,0);
   TranslateNode(n2,&T);


   m1 = MakeCyl(1000, 4000, 4, 0);
   m1->mode |= M_CONVEX;
   SmoothMesh(m1);
   RotMesh(m1,'y',64);
   m2 = MeshCpy(m1);

   SetVector(&T,0,0, 4000);
   TranslateMesh(m1,&T);
   SetVector(&T,0,0,-4000);
   TranslateMesh(m2,&T);

   n3 = Mesh2Node(m1);
   n4 = Mesh2Node(m2);
   SetVector(&V,0,0,GL_BIG);
   l1 = MakeLink(n3,n4,&V);
   n3 = Link2Node(l1);


   SetVector(&V,GL_BIG,0,0);
   l1  = MakeLink(n1,n3,&V);
   n   = Link2Node(l1);
   l   = MakeLink(n,n2,&V);

   n1  = Link2Node(l);
   n2  = NodeCpy(n1);

   SetVector(&T,0, 4000,0);
   TranslateNode(n1,&T);
   SetVector(&T,0,-4000,0);
   TranslateNode(n2,&T);


   m1 = MakeCyl(1000, 4000, 4, 0);
   m1->mode |= M_CONVEX;
   SmoothMesh(m1);
   RotMesh(m1,'x',64);
   n3 = Mesh2Node(m1);
   n4 = NodeCpy(n3);

   SetVector(&T, 4000,0,0);
   TranslateNode(n3,&T);
   SetVector(&T,-4000,0,0);
   TranslateNode(n4,&T);
   
   SetVector(&V,GL_BIG,0,0);
   l  = MakeLink(n3,n4,&V);
   n3 = Link2Node(l);
   n4 = NodeCpy(n3);

   SetVector(&T,0,0, 4000);
   TranslateNode(n3,&T);
   SetVector(&T,0,0,-4000);
   TranslateNode(n4,&T);
   
   SetVector(&V,0,0,GL_BIG);
   l  = MakeLink(n3,n4,&V);
   n3 = Link2Node(l);


   SetVector(&V,0,GL_BIG,0);
   l = MakeLink(n1,n3,&V);
   n = Link2Node(l);
   l = MakeLink(n,n2,&V);
   n = Link2Node(l);

   return n;
   }

Node *InitObj5()
   {
   Mesh *m1, *m2, *m3, *m4;
   Node *n, *n1, *n2, *n3, *n4;
   Link *l1, *l2, *l;
   Vector V1,V2,T,V;

   SetVector(&V1,-1000,-1000,-1000);
   SetVector(&V2, 1000, 1000, 1000);

   m1 = MakeBox(&V1,  &V2, 1);
   m3 = MeshCpy(m1);
   m2 = MakeCyl(1000, 4000, 4, 0);
   SmoothMesh(m2);

   SetVector(&T,0,0,4000);
   TranslateMesh(m1,&T);

   n1 = Mesh2Node(m1);
   n2 = Mesh2Node(m2);
   
   SetVector(&V,0,0,GL_BIG);
   l = MakeLink(n1,n2,&V);
   n1 = Link2Node(l);

   SetVector(&T,0,0,-4000);
   TranslateMesh(m3,&T);
   n2 = Mesh2Node(m3);
   
   SetVector(&V,0,0,GL_BIG);
   l = MakeLink(n1,n2,&V);
   n1 = Link2Node(l);
   n2 = NodeCpy(n1);

   SetVector(&T, 4000,0,0);
   TranslateNode(n1,&T);
   SetVector(&T,-4000,0,0);
   TranslateNode(n2,&T);


   m1 = MakeCyl(1000, 4000, 4, 0);
   SmoothMesh(m1);
   RotMesh(m1,'y',64);
   m2 = MeshCpy(m1);

   SetVector(&T,0,0, 4000);
   TranslateMesh(m1,&T);
   SetVector(&T,0,0,-4000);
   TranslateMesh(m2,&T);

   n3 = Mesh2Node(m1);
   n4 = Mesh2Node(m2);
   SetVector(&V,0,0,GL_BIG);
   l1 = MakeLink(n3,n4,&V);
   n3 = Link2Node(l1);


   SetVector(&V,GL_BIG,0,0);
   l1  = MakeLink(n1,n3,&V);
   n   = Link2Node(l1);
   l   = MakeLink(n,n2,&V);

   n1  = Link2Node(l);
   n2  = NodeCpy(n1);

   SetVector(&T,0, 4000,0);
   TranslateNode(n1,&T);
   SetVector(&T,0,-4000,0);
   TranslateNode(n2,&T);


   m1 = MakeCyl(1000, 4000, 4, 0);
   SmoothMesh(m1);
   RotMesh(m1,'x',64);
   n3 = Mesh2Node(m1);
   n4 = NodeCpy(n3);

   SetVector(&T, 4000,0,0);
   TranslateNode(n3,&T);
   SetVector(&T,-4000,0,0);
   TranslateNode(n4,&T);
   
   SetVector(&V,GL_BIG,0,0);
   l  = MakeLink(n3,n4,&V);
   n3 = Link2Node(l);
   n4 = NodeCpy(n3);

   SetVector(&T,0,0, 4000);
   TranslateNode(n3,&T);
   SetVector(&T,0,0,-4000);
   TranslateNode(n4,&T);
   
   SetVector(&V,0,0,GL_BIG);
   l  = MakeLink(n3,n4,&V);
   n3 = Link2Node(l);


   SetVector(&V,0,GL_BIG,0);
   l = MakeLink(n1,n3,&V);
   n = Link2Node(l);
   l = MakeLink(n,n2,&V);
   n = Link2Node(l);

   return n;
   }

void InitObj()
   {
   object[0] = InitObj1();
   object[1] = InitObj2(1);
   object[2] = InitObj2(0);
   object[3] = InitObj3();
   object[4] = InitObj4();
   object[5] = InitObj5();
   }

void TestZBuff();
	
void Test3D()
   {

   Vector L;

   char q = ' ';
   int rx  = 0, ry  = 0, rz  = 0;
   int rrx = 1, rry = 1, rrz = 1;
   Node *n;

   InitObj();

   SetVector(&L, -GL_BIG, 0, -GL_BIG);
   Normalize(&L);
   SetLight(&L);


   while(q != 'q')
     {
     if(readkbd(&q))
       switch(q)
	 {
      	 case 'a': BD -= 5; break;
      	 case 'z': BD += 5; break;
	 case '0': rx = ry = rz = 0; break;
	 case '7': rx -= rrx; break;
	 case '4': rx = 0;    break;
	 case '1': rx += rrx; break;
	 case '8': ry -= rry; break;
	 case '5': ry = 0;    break;
	 case '2': ry += rry; break;
	 case '9': rz -= rrz; break;
	 case '6': rz = 0;    break;
	 case '3': rz += rrz; break;
	 case '+': ZoomIn();  break;
	 case '-': ZoomOut(); break;
	 case 'd': dither = dither ? 0 : 1; break;
	 case 'h': help   = help   ? 0 : 1; break;
	 case 'r': tinit = now(); nframe = 0; break;
	 case 'w': mode++; mode %= nmode; break;
	 case 'o': obj++;  obj  %= nobj;  break;
	 case 'b': TestZBuff(); break;
	 }

     n = object[obj];

     RotNode(n,'x',rx);
     RotNode(n,'y',ry);
     RotNode(n,'z',rz);

     SetClip(BD,BD,D_WIDTH-BD,D_HEIGHT-BD);
     SetClipMode(CM_COLOR);
     graph_clear(6);
     DrawRect(&Clip,32);


     switch(mode)
       {
	 
       case 2:
	 SetShadeMode(S_LIGHT);

	 if(dither)
	   DrawNode(n, P_SHADE_DITHER_MODE);
	 else
	   DrawNode(n, P_SHADE_MODE);
	 break;

       case 3:
	 SetShadeMode(S_DEPTHQ);
	 SetDepthQRange(-7000,1000);

	 if(dither)
	   DrawNode(n, P_SHADE_DITHER_MODE);
	 else
	   DrawNode(n, P_SHADE_MODE);
	 break;

       case 1:
	 SetShadeMode(S_LIGHT);
	 DrawNode(n,P_FILL_COLOR_MODE); 
	 break;

       case 0:
	 SetShadeMode(S_NONE);
	 DrawNode(n,P_FILL_MODE);
	 break;

        }

     if(help)
       Help(60,50);

     graph_swap();
     nframe++;
     }

   }


	
void TestObj(char *FileName)
   {

     Mesh *gl_read_3DG1 PRM((char *FileName, int r));
     Mesh *gl_read_geo  PRM((char *FileName, int r));

   Vector L;
   int light = 0;
   char q = ' ';
   int rx  = 0, ry  = 0, rz  = 0;
   int rrx = 1, rry = 1, rrz = 1;
   Node *n;
   Mesh *m;
   polyfun p;

   m = gl_read_3DG1(FileName, 10000);
   SmoothMesh(m);
   n = Mesh2Node(m);

   SetVector(&L, -GL_BIG, 0, -GL_BIG);
   Normalize(&L);
   SetLight(&L);

   SetDepthQRange(-7000,1000);

   while(q != 'q')
     {
     if(readkbd(&q))
       switch(q)
	 {
      	 case 'a': BD -= 5; break;
      	 case 'z': BD += 5; break;
	 case '0': rx = ry = rz = 0; break;
	 case '7': rx -= rrx; break;
	 case '4': rx = 0;    break;
	 case '1': rx += rrx; break;
	 case '8': ry -= rry; break;
	 case '5': ry = 0;    break;
	 case '2': ry += rry; break;
	 case '9': rz -= rrz; break;
	 case '6': rz = 0;    break;
	 case '3': rz += rrz; break;
	 case '+': ZoomIn();  break;
	 case '-': ZoomOut(); break;
	 case 'd': dither = dither ? 0 : 1; break;
	 case 'h': help   = help   ? 0 : 1; break;
	 case 'r': tinit = now(); nframe = 0; break;
	 case 'w': light++; light %= 3; break;
	 case 'b': Test3D(); break; 
	 }

     RotNode(n,'x',rx);
     RotNode(n,'y',ry);
     RotNode(n,'z',rz);

     switch(light)
       {
       case 0:
	 SetShadeMode(S_LIGHT); 
	 p = P_ZBUFF_SHADE_MODE;
	 break;
       case 1:
	 SetShadeMode(S_DEPTHQ);
	 p = P_ZBUFF_SHADE_MODE;
	 break;
       case 2:
	 SetShadeMode(S_LIGHT);   
	 p = P_ZBUFF_MODE;
	 break;
       }

     SetClip(BD,BD,D_WIDTH-BD,D_HEIGHT-BD);
     SetClipMode(CM_COLOR);
     graph_clear(6);
     z_clear();
     DrawRect(&Clip,32);


     DrawNode(n,p);

     if(help)
       Help(60,50);

     graph_swap();
     nframe++;
     }

   }



void TestZBuff()
   {
     int mm = 0;
     int rr = 1;
     int r1x =  3, r1y = -2, r1z = 1;
     int r2x = -1, r2y =  2, r2z = 4;
     int rotate = 1;
     Vector V1,V2,L;
     Mesh *m1,*m2;
     Node *n1,*n2;
     char q=' ';

     SetClipMode(CM_COLOR | CM_Z);


     SetVector(&V1,-3000,-3000,-3000);
     SetVector(&V2, 3000, 3000, 3000);

     m1 = MakeBox(&V1,&V2,1);

     SetVector(&V1,-500,-500,-7000);
     SetVector(&V2, 500, 500, 7000);

     m2 = MakeBox(&V1,&V2,1);

     n1 = object[obj];
     n2 = NodeCpy(n1);

     SetVector(&L, -GL_BIG, 0, -GL_BIG);
     Normalize(&L);
     SetLight(&L);

     while(q != 'q')
       {
       if(readkbd(&q))
	 switch(q)
	   {
	   case 'a':
	     rotate = rotate ? 0 : 1; break;
	   case '+': ZoomIn();  break;
	   case '-': ZoomOut(); break;
	   case 'w': mm = mm ? 0 : 1; break;
	   case 'z': rr++; rr %= 3; break;
	   }

	 if(rotate)
	   {
	     RotNode(n1,'x',r1x);
	     RotNode(n1,'y',r1y);
	     RotNode(n1,'z',r1z);
	     if(rr == 1)
	       {
		 RotNode(n2,'x',r2x);
		 RotNode(n2,'y',r2y);
		 RotNode(n2,'z',r2z);
	       }
	     if(rr == 2)
	       {
		 RotNode(n2,'x',r1x);
		 RotNode(n2,'y',r1y);
		 RotNode(n2,'z',r1z);
	       }
           }
	 readkbd(&q);
       
         if(mm)
           SetShadeMode(S_DEPTHQ);
         else
	   SetShadeMode(S_LIGHT);

	 z_clear();
	 graph_clear(6);
	 DrawNode(n1,P_ZBUFF_SHADE_MODE);
	 DrawNode(n2,P_ZBUFF_SHADE_MODE); 
	 graph_swap();
       }
   
   }

int main(argc, argv)
     int    argc;
     char **argv;
   {
   OpenS();
   InitColormap();
   SetClipMode(CM_COLOR);
   d_graph_mem = v_graph_mem;
   tinit = now();
/*    TestObj(argv[1]); */

   Test3D();

   CloseS();
   return 0;
   }





